diff --git a/tests/modeltests/model_formsets/models.py b/tests/modeltests/model_formsets/models.py
index cac73d7..e3fce2f 100644
--- a/tests/modeltests/model_formsets/models.py
+++ b/tests/modeltests/model_formsets/models.py
@@ -30,6 +30,7 @@ __test__ = {'API_TESTS': """
 
 >>> data = {
 ...     'form-COUNT': '3',
+...     'form-REQUIRED': '0', # number of forms filled before
 ...     'form-0-name': 'Charles Baudelaire',
 ...     'form-1-name': 'Arthur Rimbaud',
 ...     'form-2-name': '',
@@ -66,6 +67,7 @@ but in that case we'll use it to display them in alphabetical order by name.
 
 >>> data = {
 ...     'form-COUNT': '3',
+...     'form-REQUIRED': '2', # number of forms filled before
 ...     'form-0-id': '2',
 ...     'form-0-name': 'Arthur Rimbaud',
 ...     'form-1-id': '1',
@@ -107,6 +109,7 @@ deltetion, make sure we don't save that form.
 
 >>> data = {
 ...     'form-COUNT': '4',
+...     'form-REQUIRED': '3', # number of forms filled before
 ...     'form-0-id': '2',
 ...     'form-0-name': 'Arthur Rimbaud',
 ...     'form-1-id': '1',
@@ -148,6 +151,7 @@ admin system's edit inline functionality works.
 
 >>> data = {
 ...     'book_set-COUNT': '3',
+...     'book_set-REQUIRED': '0', # number of forms filled before
 ...     'book_set-0-title': 'Les Fleurs du Mal',
 ...     'book_set-1-title': '',
 ...     'book_set-2-title': '',
@@ -181,6 +185,7 @@ book.
 
 >>> data = {
 ...     'book_set-COUNT': '3',
+...     'book_set-REQUIRED': '1', # number of forms filled before
 ...     'book_set-0-id': '1',
 ...     'book_set-0-title': 'Les Fleurs du Mal',
 ...     'book_set-1-title': 'Le Spleen de Paris',
diff --git a/tests/regressiontests/forms/formsets.py b/tests/regressiontests/forms/formsets.py
index a6da2fe..6c1cb6d 100644
--- a/tests/regressiontests/forms/formsets.py
+++ b/tests/regressiontests/forms/formsets.py
@@ -33,6 +33,7 @@ the COUNT field appropriately.
 
 >>> data = {
 ...     'choices-COUNT': '1', # the number of forms rendered
+...     'choices-REQUIRED': '0', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '100',
 ... }
@@ -58,6 +59,8 @@ any of the forms.
 
 >>> data = {
 ...     'choices-COUNT': '1', # the number of forms rendered
+...     'choices-REQUIRED': '1', # number of forms filled before
+...     'choices-REQUIRED': '0', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '',
 ... }
@@ -94,6 +97,7 @@ Let's simulate what would happen if we submitted this form.
 
 >>> data = {
 ...     'choices-COUNT': '2', # the number of forms rendered
+...     'choices-REQUIRED': '1', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '100',
 ...     'choices-1-choice': '',
@@ -114,6 +118,7 @@ handle that later.
 
 >>> data = {
 ...     'choices-COUNT': '2', # the number of forms rendered
+...     'choices-REQUIRED': '1', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '100',
 ...     'choices-1-choice': 'The Decemberists',
@@ -133,6 +138,7 @@ handle that case later.
 
 >>> data = {
 ...     'choices-COUNT': '2', # the number of forms rendered
+...     'choices-REQUIRED': '1', # number of forms filled before
 ...     'choices-0-choice': '', # deleted value
 ...     'choices-0-votes': '', # deleted value
 ...     'choices-1-choice': '',
@@ -169,6 +175,7 @@ number of forms to be completed.
 
 >>> data = {
 ...     'choices-COUNT': '3', # the number of forms rendered
+...     'choices-REQUIRED': '0', # number of forms filled before
 ...     'choices-0-choice': '',
 ...     'choices-0-votes': '',
 ...     'choices-1-choice': '',
@@ -188,6 +195,7 @@ We can just fill out one of the forms.
 
 >>> data = {
 ...     'choices-COUNT': '3', # the number of forms rendered
+...     'choices-REQUIRED': '0', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '100',
 ...     'choices-1-choice': '',
@@ -207,6 +215,7 @@ And once again, if we try to partially complete a form, validation will fail.
 
 >>> data = {
 ...     'choices-COUNT': '3', # the number of forms rendered
+...     'choices-REQUIRED': '0', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '100',
 ...     'choices-1-choice': 'The Decemberists',
@@ -244,6 +253,7 @@ get an error.
 
 >>> data = {
 ...     'choices-COUNT': '3', # the number of forms rendered
+...     'choices-REQUIRED': '1', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '100',
 ...     'choices-1-choice': '',
@@ -289,6 +299,7 @@ To delete something, we just need to set that form's special delete field to
 
 >>> data = {
 ...     'choices-COUNT': '3', # the number of forms rendered
+...     'choices-REQUIRED': '2', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '100',
 ...     'choices-0-DELETE': '',
@@ -336,6 +347,7 @@ something at the front of the list, you'd need to set it's order to 0.
 
 >>> data = {
 ...     'choices-COUNT': '3', # the number of forms rendered
+...     'choices-REQUIRED': '2', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '100',
 ...     'choices-0-ORDER': '1',
@@ -391,6 +403,7 @@ Let's delete Fergie, and put The Decemberists ahead of Calexico.
 
 >>> data = {
 ...     'choices-COUNT': '4', # the number of forms rendered
+...     'choices-REQUIRED': '3', # number of forms filled before
 ...     'choices-0-choice': 'Calexico',
 ...     'choices-0-votes': '100',
 ...     'choices-0-ORDER': '1',
@@ -451,6 +464,7 @@ We start out with a some duplicate data.
 
 >>> data = {
 ...     'drinks-COUNT': '2',
+...     'drinks-REQUIRED': '0', # number of forms filled before
 ...     'drinks-0-name': 'Gin and Tonic',
 ...     'drinks-1-name': 'Gin and Tonic',
 ... }
@@ -471,6 +485,7 @@ Make sure we didn't break the valid case.
 
 >>> data = {
 ...     'drinks-COUNT': '2',
+...     'drinks-REQUIRED': '0', # number of forms filled before
 ...     'drinks-0-name': 'Gin and Tonic',
 ...     'drinks-1-name': 'Bloody Mary',
 ... }