Index: django/contrib/comments/views/karma.py
===================================================================
--- django/contrib/comments/views/karma.py	(revision 6678)
+++ django/contrib/comments/views/karma.py	(working copy)
@@ -4,7 +4,8 @@
 from django.contrib.comments.models import Comment, KarmaScore
 from django.utils.translation import ugettext as _
 
-def vote(request, comment_id, vote, extra_context=None, context_processors=None):
+def vote(request, comment_id, vote, template_name='comments/karma_vote_accepted.html',
+         extra_context=None, context_processors=None):
     """
     Rate a comment (+1 or -1)
 
@@ -28,5 +29,5 @@
     KarmaScore.objects.vote(request.user.id, comment_id, rating)
     # Reload comment to ensure we have up to date karma count
     comment = Comment.objects.get(pk=comment_id)
-    return render_to_response('comments/karma_vote_accepted.html', {'comment': comment},
+    return render_to_response(template_name, {'comment': comment},
         context_instance=RequestContext(request, extra_context, context_processors))
Index: django/contrib/comments/views/userflags.py
===================================================================
--- django/contrib/comments/views/userflags.py	(revision 6678)
+++ django/contrib/comments/views/userflags.py	(working copy)
@@ -6,7 +6,8 @@
 from django.http import HttpResponseRedirect
 from django.conf import settings
 
-def flag(request, comment_id, extra_context=None, context_processors=None):
+def flag(request, comment_id, template_name='comments/flag_verify.html',
+         extra_context=None, context_processors=None):
     """
     Flags a comment. Confirmation on GET, action on POST.
 
@@ -20,17 +21,19 @@
     if request.POST:
         UserFlag.objects.flag(comment, request.user)
         return HttpResponseRedirect('%sdone/' % request.path)
-    return render_to_response('comments/flag_verify.html', {'comment': comment},
+    return render_to_response(template_name, {'comment': comment},
         context_instance=RequestContext(request, extra_context, context_processors))
 flag = login_required(flag)
 
-def flag_done(request, comment_id, extra_context=None, context_processors=None):
+def flag_done(request, comment_id, template_name='comments/flag_done.html',
+              extra_context=None, context_processors=None):
     if extra_context is None: extra_context = {}
     comment = get_object_or_404(Comment,pk=comment_id, site__id__exact=settings.SITE_ID)
-    return render_to_response('comments/flag_done.html', {'comment': comment},
+    return render_to_response(template_name, {'comment': comment},
         context_instance=RequestContext(request, extra_context, context_processors))
 
-def delete(request, comment_id, extra_context=None, context_processors=None):
+def delete(request, comment_id, template_name='comments/delete_verify.html',
+           extra_context=None, context_processors=None):
     """
     Deletes a comment. Confirmation on GET, action on POST.
 
@@ -51,12 +54,13 @@
             m = ModeratorDeletion(None, request.user.id, comment.id, None)
             m.save()
         return HttpResponseRedirect('%sdone/' % request.path)
-    return render_to_response('comments/delete_verify.html', {'comment': comment},
+    return render_to_response(template_name, {'comment': comment},
         context_instance=RequestContext(request, extra_context, context_processors))
 delete = login_required(delete)
 
-def delete_done(request, comment_id, extra_context=None, context_processors=None):
+def delete_done(request, comment_id, template_name='comments/delete_done.html',
+                extra_context=None, context_processors=None):
     if extra_context is None: extra_context = {}
     comment = get_object_or_404(Comment,pk=comment_id, site__id__exact=settings.SITE_ID)
-    return render_to_response('comments/delete_done.html', {'comment': comment},
+    return render_to_response(template_name, {'comment': comment},
         context_instance=RequestContext(request, extra_context, context_processors))
Index: django/contrib/comments/views/comments.py
===================================================================
--- django/contrib/comments/views/comments.py	(revision 6678)
+++ django/contrib/comments/views/comments.py	(working copy)
@@ -155,7 +155,7 @@
         c.save()
         return c
 
-def post_comment(request, extra_context=None, context_processors=None):
+def post_comment(request, template_name='comments/preview.html', extra_context=None, context_processors=None):
     """
     Post a comment
 
@@ -234,7 +234,7 @@
                 return field_list
         comment = errors and '' or manipulator.get_comment(new_data)
         comment_form = CommentFormWrapper(manipulator, new_data, errors, rating_choices)
-        return render_to_response('comments/preview.html', {
+        return render_to_response(template_name, {
             'comment': comment,
             'comment_form': comment_form,
             'options': options,
@@ -258,7 +258,7 @@
     else:
         raise Http404, _("The comment form didn't provide either 'preview' or 'post'")
 
-def post_free_comment(request, extra_context=None, context_processors=None):
+def post_free_comment(request, template_name='comments/free_preview.html', extra_context=None, context_processors=None):
     """
     Post a free comment (not requiring a log in)
 
@@ -303,7 +303,7 @@
     errors = manipulator.get_validation_errors(new_data)
     if errors or 'preview' in request.POST:
         comment = errors and '' or manipulator.get_comment(new_data)
-        return render_to_response('comments/free_preview.html', {
+        return render_to_response(template_name, {
             'comment': comment,
             'comment_form': oldforms.FormWrapper(manipulator, new_data, errors),
             'options': options,
@@ -323,7 +323,7 @@
     else:
         raise Http404, _("The comment form didn't provide either 'preview' or 'post'")
 
-def comment_was_posted(request, extra_context=None, context_processors=None):
+def comment_was_posted(request, template_name='comments/posted.html', extra_context=None, context_processors=None):
     """
     Display "comment was posted" success page
 
@@ -341,5 +341,5 @@
             obj = content_type.get_object_for_this_type(pk=object_id)
         except ObjectDoesNotExist:
             pass
-    return render_to_response('comments/posted.html', {'object': obj},
+    return render_to_response(template_name, {'object': obj},
         context_instance=RequestContext(request, extra_context, context_processors))